/*
 * WallFire -- a comprehensive firewall administration tool.
 * 
 * Copyright (C) 2001 Herv Eychenne <rv@wallfire.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

using namespace std;

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "conf.h"
#include "defs.h"


wf_outmodule_ipchains_conf::wf_outmodule_ipchains_conf() {
  config.option_add("verbose", WF_OPTION_TYPE_INT,
		    _("verbosity level"), "");
  config.option_add("summary", WF_OPTION_TYPE_BOOL,
		    _("summary mode"), "");

  config["verbose"] = 0;
  config["summary"] = false;
}

ostream&
wf_outmodule_ipchains_conf::print(ostream& os) const {
  os << "PRINT IPCHAINS CONFIG" << endl;
  // RV@@8
  return os;
}
